<?xml version="1.0" encoding="UTF-8"?>
<!--
-
- IBM Confidential
- OCO Source Materials
- 
- (C) Copyright IBM Corporation 2007. All rights reserved. 
-                                                                                   
- The source code for this program is not published or otherwise divested of
- its trade secrets, irrespective of what has been deposited with the U.S. 
- Copyright Office. 
- 
-->
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="UTF-8"/>
<!-- xsl:include isn't working in ISC but working in WAS
 <xsl:include href="ReportStyle.xsl"/> 
-->
<xsl:variable name="css">
BODY {
      PADDING-RIGHT: 0px; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; MARGIN: 0px; PADDING-TOP: 0px; BACKGROUND-COLOR: white; TEXT-ALIGN: left; FONT-FAMILY: Verdana, Arial, Sans-serif;
}
DIV.letterhead {
      FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-WEIGHT: bold; FONT-SIZE: 80%; BACKGROUND-COLOR: #D1EDF9; border: 1px solid #a9a9a9; padding:10px; 
  }
DIV.letterheadtitle {
  padding:0px; font-size:80%;
}

DIV.letterheadtitle table {
  border-collapse: collapse; width:100%; padding-left:10px; font-size:100%;
}
DIV.letterheadtitle td {
  padding:10px; border:1px solid #a9a9a9; border-top: none; vertical-align:top;
}

DIV.letterheadtitle table table td, DIV.letterheadtitle table table th {
  padding:0px; border:none; vertical-align:top; text-align:left;
}


DIV.subtitle, DIV.subtitle_only {
  padding:10px; font-size:80%; border:1px solid #a9a9a9; background:#5090D0; font-weight:bold; color:#FFFFFF
}
DIV.subtitle {
  border-bottom:0px;
}

UL.letterhead {
    PADDING-RIGHT: 0px; MARGIN-TOP: 0px; DISPLAY: inline; PADDING-LEFT: 0px; LIST-STYLE-IMAGE: none; PADDING-BOTTOM: 0px; MARGIN-RIGHT: 0px; PADDING-TOP: 0px; LIST-STYLE-TYPE: none; float:right; WHITE-SPACE: nowrap; padding-left: 20px;
}
LI.letterhead {
    DISPLAY: inline
}
A.letterhead:link {
    TEXT-DECORATION: none
}
A.letterhead:visited {
    TEXT-DECORATION: none
}
A.letterhead:hover {
    TEXT-DECORATION: underline
}
A.letterhead:active {
    TEXT-DECORATION: none
}

.style3 {color: #FF0000}


TABLE.reportTable TD, TABLE.reportTABLE TH {
	border: 1px inset #cccccc;
	vertical-align: top;
    padding-left:4px;
    padding-right:4px;
}

TABLE.reportTable TD.number, TABLE.reportTable TH.number {
  text-align:right;
}
TABLE.reportTable {
    border: 1px solid #a9a9a9;
	border-collapse: collapse;
	width:100%;
	font-size:80%;
	padding-left:1em;
}
TABLE.reportTable TH {
  background: #D1EDF9;
  font-weight: bold;
}

TABLE.reportTable TH.centerHeader {
  text-align:center;
}

TABLE.reportTable TH {
  text-align:left;
}

TABLE.reportTable TD.error {
  background: #ffcccc;
  font-weight: bold;
}
TABLE.reportTable TD.errortext, TABLE.reportTable TR.total {
  font-weight: bold;
}

TABLE.reportTable TR.even {
  background: #F5F4F4;  
}

IMG.latency {
  border:1px solid #a9a9a9
}
</xsl:variable>
  <xsl:variable name="link.Help" select="//resources/link_help"/>
  <xsl:variable name="link.Technotes" select="//resources/title_technotes"/>
  <xsl:variable name="title.Exceptions" select="//resources/title_exceptions"/>  
  <xsl:variable name="title.DateGenerated" select="//resources/title_dategenerated"/>  
  <xsl:variable name="title.TimeRange" select="//resources/title_timerange"/>    
  <xsl:variable name="title.NumberOfMessages" select="//resources/title_numberofmessages"/>    
  <xsl:variable name="title.NoData" select="//resources/title_nodata"/>
  <xsl:variable name="title.ProgramsInReport" select="//resources/title_programsinreport"/>    
  <xsl:variable name="title.QueuesInReport" select="//resources/title_queuesinreport"/>   
  
  <xsl:variable name="summary.Title" select="//resources/summary_title"/>    
  <xsl:variable name="summary.Queue" select="//resources/summary_queue"/>    
  <xsl:variable name="summary.Total" select="//resources/summary_total"/>      
  <xsl:variable name="summary.Insert" select="//resources/summary_insert"/>    
  <xsl:variable name="summary.Update" select="//resources/summary_update"/>    
  <xsl:variable name="summary.Delete" select="//resources/summary_delete"/>
  <xsl:variable name="summary.Applied" select="//resources/summary_applied"/>      
  <xsl:variable name="summary.NotApplied" select="//resources/summary_notapplied"/>  
  
  <xsl:variable name="exception.Title" select="//resources/table_title"/>  
  <xsl:variable name="exception.Row" select="//resources/table_row"/>   
  <xsl:variable name="exception.Time" select="//resources/table_time"/>  
  <xsl:variable name="exception.RecvQueue" select="//resources/table_recvqueue"/>
  <xsl:variable name="exception.SubName" select="//resources/table_subname"/>
  <xsl:variable name="exception.Reason" select="//resources/table_reason"/>  
  <xsl:variable name="exception.Operation" select="//resources/table_operation"/>
  <xsl:variable name="exception.Exception" select="//resources/table_exception"/>
 
<!--  <xsl:variable name="controlTable.TIME" select="//resources/ctable_time"/>  -->
  <xsl:variable name="controlTable.SRC_TRANS_TIME" select="//resources/ctable_srctranstime"/>
  <xsl:variable name="controlTable.SRC_COMMIT" select="//resources/ctable_srccommit"/>
  <xsl:variable name="controlTable.REASON" select="//resources/ctable_reason"/>
  <xsl:variable name="controlTable.SQLCODE" select="//resources/ctable_sqlcode"/>
  <xsl:variable name="controlTable.SQLSTATE" select="//resources/ctable_sqlstate"/>
  <xsl:variable name="controlTable.SQLERRMC" select="//resources/ctable_sqlerrmc"/>
  <xsl:variable name="controlTable.SUBNAME" select="//resources/ctable_subname"/>
  <xsl:variable name="controlTable.RECVQUEUE" select="//resources/ctable_recvqueue"/>      
  <xsl:variable name="controlTable.EBCDIC" select="//resources/ctable_ebcdic"/>
  <xsl:variable name="controlTable.ASCII" select="//resources/ctable_ascii"/>
  <xsl:variable name="controlTable.HEX" select="//resources/ctable_hex"/>
  <xsl:variable name="controlTable.OPERATION" select="//resources/ctable_operation"/>                    
  <xsl:variable name="controlTable.IS_APPLIED" select="//resources/ctable_isapplied"/>                    
  <xsl:variable name="controlTable.CONFLICT_RULE" select="//resources/ctable_conflictrule"/> 

  <xsl:variable name="numberOfMessages" select="//total" />
  
<xsl:template match="/">  
<html>  
<head>
<title><xsl:value-of select="$title.Exceptions" disable-output-escaping="yes"/> - <xsl:value-of select="//viewName" disable-output-escaping="yes"/> - <xsl:value-of select="//title_servers" disable-output-escaping="yes"/> - <xsl:value-of select="//date" disable-output-escaping="yes"/></title>
     <style type="text/css">
     <xsl:value-of select="$css"/>
     </style>
</head>
<body>
   
	<DIV class="letterhead">
  
    <!-- links to the DB2 Info center and Technotes -->
	<UL class="letterhead">
		<LI class="letterhead"><A class="letterhead"
			href="http://publib.boulder.ibm.com/infocenter/db2luw/v9r5/topic/com.ibm.swg.im.iis.repl.qrepl.doc/topics/iiyrqrepcexcepts.html"
			target="_BLANK"><xsl:value-of select="$link.Help" disable-output-escaping="yes"/></A>
		</LI>
	  	<LI class="letterhead">|</LI>
		<LI class="letterhead"><A class="letterhead"
			href="http://www.ibm.com/support/search.wss?tc=SS2K6Z+SS9UMX+SS2KAH&amp;rs=3171&amp;rank=8&amp;dc=DB520+D800+D900+DA900+DA800&amp;dtm&amp;q1=Q+Apply+exceptions"
			target="_BLANK"><xsl:value-of select="$link.Technotes" disable-output-escaping="yes"/></A>
		</LI>
	</UL>
    <div>	    
   		    <xsl:value-of select="$title.Exceptions" disable-output-escaping="yes"/>
    </div>	
    </DIV>


	<div class="letterheadtitle">		    
	<table><tr><td>
	  <table>
        <tr>
	        <!-- Date generated and time range for the report -->
			<th><xsl:value-of select="$title.DateGenerated" disable-output-escaping="yes"/></th>
			<td><xsl:value-of select="//date" disable-output-escaping="yes"/></td>
		</tr>
		<tr>
			<th><xsl:value-of select="$title.TimeRange" disable-output-escaping="yes"/></th>
			<td><xsl:value-of select="//timerange" disable-output-escaping="yes"/></td>
		</tr>
		<tr>
			<th><xsl:value-of select="$title.NumberOfMessages" disable-output-escaping="yes"/></th>
			<td><xsl:value-of select="//total"/></td>
		</tr>		
		<tr>
		  <th><xsl:value-of select="$title.ProgramsInReport" disable-output-escaping="yes"/></th>
          <td>
			    <!-- list of server names -->
			<xsl:for-each select = "//server" > 
				<xsl:value-of select = "." disable-output-escaping="yes"/> 
			    <!-- add a comma unless it's the last server -->
				<xsl:if test = "not(position()=last())" > 
					<xsl:text >, </xsl:text> 
				</xsl:if> 
			</xsl:for-each>
          </td>
        </tr>
        <tr>        
          <th><xsl:value-of select="$title.QueuesInReport" disable-output-escaping="yes"/></th>
	  	  <td><xsl:value-of select="//context" disable-output-escaping="yes"/></td>
        </tr>        
        </table>
     </td></tr></table>
	</div>   

	<xsl:choose>
		<xsl:when test="$numberOfMessages = 0">
		  <div class="subtitle_only">
			<xsl:value-of select="$title.NoData" disable-output-escaping="yes"/>
		  </div>
		</xsl:when> 
		<xsl:otherwise>		

		<!-- begin of statistical summary -->
		
		  	<!-- summary table for the number of errors, warnings, last error and last warning -->
		    <div class="subtitle">
			<xsl:value-of select="$summary.Title" disable-output-escaping="yes"/>
			</div>
			<table class="reportTable" summary="Statistical summary">
				<tr>
					<th></th> 
					<th class="centerHeader" colspan="2" scope="col"><xsl:value-of select="$summary.Total" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" colspan="2" scope="col"><xsl:value-of select="$summary.Insert" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" colspan="2" scope="col"><xsl:value-of select="$summary.Update" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" colspan="2" scope="col"><xsl:value-of select="$summary.Delete" disable-output-escaping="yes"/></th> 			
				</tr>
				<tr>
					<th><xsl:value-of select="$summary.Queue" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" ><xsl:value-of select="$summary.Applied" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" ><xsl:value-of select="$summary.NotApplied" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" ><xsl:value-of select="$summary.Applied" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" ><xsl:value-of select="$summary.NotApplied" disable-output-escaping="yes"/></th> 
					<th class="centerHeader" ><xsl:value-of select="$summary.Applied" disable-output-escaping="yes"/></th> 		
					<th class="centerHeader" ><xsl:value-of select="$summary.NotApplied" disable-output-escaping="yes"/></th> 						
					<th class="centerHeader" ><xsl:value-of select="$summary.Applied" disable-output-escaping="yes"/></th> 		
					<th class="centerHeader" ><xsl:value-of select="$summary.NotApplied" disable-output-escaping="yes"/></th> 						
				</tr>

		 		<xsl:for-each select = "//summarycontextrow" > 	
					<tr>
						<xsl:if test="position() mod 2 != 1">
						    <xsl:attribute  name="class">even</xsl:attribute>
				        </xsl:if>
						<td>
							<xsl:value-of select="context" />
						</td>
						<td class="number">
							<xsl:value-of select="applied_total" />
						</td>
						<td class="number">
							<xsl:value-of select="notapplied_total" />
						</td>
						<td class="number">
							<xsl:value-of select="applied_insert" />
						</td>
						<td class="number">
							<xsl:value-of select="notapplied_insert" />
						</td>
						<td class="number">
							<xsl:value-of select="applied_update" />
						</td>
						<td class="number">
							<xsl:value-of select="notapplied_update" />
						</td>
						<td class="number">
							<xsl:value-of select="applied_delete" />
						</td>
						<td class="number">
							<xsl:value-of select="notapplied_delete" />
						</td>
					</tr>
		 		</xsl:for-each>
		
		 		<tr class="total" scope="row">
		 			<td></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/applied_total" /></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/notapplied_total" /></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/applied_insert" /></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/notapplied_insert" /></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/applied_update" /></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/notapplied_update" /></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/applied_delete" /></td>
		 			<td class="number"><xsl:value-of select="//summarycontextrow/notapplied_delete" /></td>
		 		</tr>
			</table>
		   		
			<p/>   		    	    
			<!-- end of statistical summary -->
			
			<div class="subtitle">
			  	<xsl:value-of select="$exception.Title" disable-output-escaping="yes"/>
		    </div>
			
			<table class="reportTable" summary="Messages">
				<tr>
					<th align="left" scope="col"><xsl:value-of select="$exception.Row" disable-output-escaping="yes"/></th> 
					<th align="left" scope="col"><xsl:value-of select="$exception.Time" disable-output-escaping="yes"/></th>
		<!--  			<th align="left"><xsl:value-of select="$exception.RecvQueue"/></th> -->
		<!-- 			<th align="left"><xsl:value-of select="$exception.SubName"/></th>  -->
					<th align="left" scope="col"><xsl:value-of select="$exception.Reason" disable-output-escaping="yes"/></th>        
		<!--			<th align="left"><xsl:value-of select="$exception.Operation"/></th> -->
					<th align="left" scope="col"><xsl:value-of select="$exception.Exception" disable-output-escaping="yes"/></th>
				</tr>
				

				<!-- Details for all exceptions messages -->
				<xsl:for-each select="exceptions/exception">
					<tr>
						<xsl:if test="position() mod 2 != 1">
				          <xsl:attribute name="class">even</xsl:attribute>
					    </xsl:if>
						<td class="number"><xsl:number/></td>
						<td><xsl:value-of select="time" />
						</td>
						<!--  <td></td>-->
						<!--  <td><xsl:value-of select="subname" /></td>-->
						<td>
							<xsl:value-of select="$controlTable.OPERATION" disable-output-escaping="yes"/>
										<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
										<xsl:value-of select="operation" />
							<br/>
							<xsl:value-of select="$controlTable.REASON" disable-output-escaping="yes"/>
										<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
										<xsl:apply-templates select="reason" mode="addReasonLink" />
							<br/><br/>
							<xsl:value-of select="$controlTable.SQLCODE" disable-output-escaping="yes"/>
										<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
		 								<xsl:apply-templates select="sqlcode" mode="addSQLLinks" /> 
							<br/>
							<xsl:value-of select="$controlTable.SQLSTATE" disable-output-escaping="yes"/>
										<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
							<a>
								<xsl:attribute name="href">	
										<xsl:text>http://publib.boulder.ibm.com/infocenter/db2luw/v9r5/topic/com.ibm.db2.luw.messages.doc/doc/rdb2stt.html</xsl:text>
								</xsl:attribute>
								<xsl:attribute name="target">	
									<xsl:text>_blank</xsl:text>
								</xsl:attribute>
								<xsl:value-of select="sqlstate" /> 											
							</a>
							<br/><br/>
							<xsl:value-of select="$controlTable.CONFLICT_RULE" disable-output-escaping="yes"/>
								<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								<xsl:apply-templates select="conflictrule" mode="addExceptionTableLink" />
							<br/><br/>
							<xsl:value-of select="$controlTable.IS_APPLIED" disable-output-escaping="yes"/>
								<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								<xsl:apply-templates select="isapplied" mode="addExceptionTableLink" />
							<br/><br/>
							<xsl:value-of select="$controlTable.RECVQUEUE" disable-output-escaping="yes"/>
								<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								<xsl:value-of select="recvq" disable-output-escaping="yes"/>
							<br/>
							<xsl:value-of select="$controlTable.SUBNAME" disable-output-escaping="yes"/>
								<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								<xsl:value-of select="subname" disable-output-escaping="yes"/>
							<br/><br/>
							<xsl:value-of select="$controlTable.SRC_TRANS_TIME" disable-output-escaping="yes"/>
								<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								<xsl:value-of select="scrtranstime" />
							<br/>
							<xsl:value-of select="$controlTable.SRC_COMMIT" disable-output-escaping="yes"/>
								<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
								<xsl:value-of select="scrcommit" />
							<br/><br/>
							<xsl:value-of select="$controlTable.SQLERRMC" disable-output-escaping="yes"/><br/>
							<xsl:value-of select="$controlTable.EBCDIC" disable-output-escaping="yes"/><br/>					
							<xsl:value-of select="sqlerrmc_ebcdic" disable-output-escaping="yes"/><br/>
							<xsl:value-of select="$controlTable.ASCII" disable-output-escaping="yes"/><br/>
							<xsl:value-of select="sqlerrmc_ascii" disable-output-escaping="yes"/><br/>
							<xsl:value-of select="$controlTable.HEX" disable-output-escaping="yes"/><br/>
							<xsl:value-of select="sqlerrmc_hex" />         											
						</td>
						<td><xsl:apply-templates select="text" mode="addLineBreaks" /></td>
					</tr>
				</xsl:for-each>
			</table>
		</xsl:otherwise> 
	</xsl:choose>		
</body>
</html>
</xsl:template>

<!-- add the link to the right web page for the SQL message ID  -->
<xsl:template match="sqlcode" mode="addSQLLinks" name="addSQLLinks">
	<xsl:param name="string" select="." />

	<xsl:variable name="linkString" select="substring-after($string, '-')" />
	<a>
<!-- can't link to particular page in Infocenter 9.5 anymore for SQL messages - not enough information in control tables :-( -->
<!--		
		<xsl:attribute name="href">	
			<xsl:text>http://publib.boulder.ibm.com/infocenter/db2luw/v9/topic/com.ibm.db2.udb.msg.doc/doc/sql</xsl:text>
			<xsl:if test = "string-length($linkString)=3" > 
				<xsl:text>0</xsl:text> 
			</xsl:if> 			
			<xsl:value-of select="$linkString"/>
			<xsl:text>.htm</xsl:text>
		</xsl:attribute>
-->
		<xsl:attribute name="href">	
			<xsl:text>http://publib.boulder.ibm.com/infocenter/db2luw/v9r5/topic/com.ibm.db2.luw.messages.sql.doc/doc/rsqlmsg.html</xsl:text>
		</xsl:attribute>
		<xsl:attribute name="target">	
			<xsl:text>_blank</xsl:text>
		</xsl:attribute>
		<xsl:value-of select="$string"/>
		<xsl:text> </xsl:text>
	</a>
</xsl:template>


<!-- add the link to exceptions table description  -->
<xsl:template match="node()" mode="addExceptionTableLink" name="addExceptionTableLink">
	<xsl:param name="string" select="." />

	<xsl:choose>
		<xsl:when test="$string=''">
			<xsl:value-of select="$string" />
		</xsl:when>
		<xsl:otherwise>
			<a>
				<xsl:attribute name="href">	
					<xsl:text>http://publib.boulder.ibm.com/infocenter/db2luw/v9r5/topic/com.ibm.swg.im.iis.repl.qrepl.doc/topics/iiyrqctbrexceptn.html</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="target">	
					<xsl:text>_blank</xsl:text>
				</xsl:attribute>
				<xsl:value-of select="$string"/>				
			</a>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- add the link for REASON=CHECKFAILED  -->
<xsl:template match="reason" mode="addReasonLink" name="addReasonLink">
	<xsl:param name="string" select="." />

	<xsl:choose>
		<!-- if REASON is not CHECKFAILED just return the string as-is -->
		<xsl:when test="$string!='CHECKFAILED'">
			<xsl:apply-templates select="$string" mode="addExceptionTableLink" />
		</xsl:when>
		<xsl:otherwise>
			<a>
				<xsl:attribute name="href">	
					<xsl:text>http://www-1.ibm.com/support/docview.wss?rs=3174&amp;uid=swg21223208</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="target">	
					<xsl:text>_blank</xsl:text>
				</xsl:attribute>
				<xsl:value-of select="$string"/>				
			</a>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="node()" mode="addLineBreaks" name="addLineBreaks">
	<xsl:param name="text" select="." />
	<xsl:choose>
		<!-- if there is a line break add the string before the line break and add a <br> -->
		<xsl:when test="contains($text, '&#xA;')">

			<xsl:value-of select="substring-before($text, '&#xA;')" disable-output-escaping="yes" />
			<br />
	      
			<!-- call template recursively for the rest of the text behind the linebreak -->
			<xsl:call-template name="addLineBreaks">
				<xsl:with-param name="text" select="substring-after($text, '&#xA;')" />
			</xsl:call-template>
		</xsl:when>
		<!-- if the remaining text doesn't contain a line break, just return the text and a line break -->
		<xsl:otherwise>
			<xsl:value-of select="$text" disable-output-escaping="yes" /><br/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>