<?xml version="1.0" encoding="ISO-8859-1"?>
<!--
-
- IBM Confidential
- OCO Source Materials
- 
- (C) Copyright IBM Corporation 2007. All rights reserved. 
-                                                                                   
- The source code for this program is not published or otherwise divested of
- its trade secrets, irrespective of what has been deposited with the U.S. 
- Copyright Office. 
- 
-->
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:local="local">
<!-- This file is intended to serve as a common css style for report
xslts.  However, it's not working in ISC but WAS is fine. -->
<xsl:variable name="css">
BODY {
      PADDING-RIGHT: 0px; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; MARGIN: 0px; PADDING-TOP: 0px; BACKGROUND-COLOR: white; TEXT-ALIGN: left; FONT-FAMILY: Verdana, Arial, Sans-serif;
}
DIV.letterhead {
      FONT-FAMILY: Verdana, Arial, Helvetica, sans-serif; FONT-WEIGHT: bold; FONT-SIZE: 80%; BACKGROUND-COLOR: rgb(192,224,159); border: 1px solid #a9a9a9; padding:10px; 
  }
DIV.letterheadtitle {
  padding:0px; font-size:80%;
}

DIV.letterheadtitle table {
  border-collapse: collapse; width:100%; padding-left:10px; font-size:100%;
}
DIV.letterheadtitle td {
  padding:10px; border:1px solid #a9a9a9; border-top: none; vertical-align:top;
}

DIV.subtitle, DIV.subtitle_only {
  padding:10px; font-size:80%; border:1px solid #a9a9a9; background:#eee; font-weight:bold;
}
DIV.subtitle {
  border-bottom:0px;
}

UL.letterhead {
    PADDING-RIGHT: 0px; MARGIN-TOP: 0px; DISPLAY: inline; PADDING-LEFT: 0px; LIST-STYLE-IMAGE: none; PADDING-BOTTOM: 0px; MARGIN-RIGHT: 0px; PADDING-TOP: 0px; LIST-STYLE-TYPE: none; float:right; WHITE-SPACE: nowrap; padding-left: 20px;
}
LI.letterhead {
    DISPLAY: inline
}
A.letterhead:link {
    TEXT-DECORATION: none
}
A.letterhead:visited {
    TEXT-DECORATION: none
}
A.letterhead:hover {
    TEXT-DECORATION: underline
}
A.letterhead:active {
    TEXT-DECORATION: none
}

.style3 {color: #FF0000}


TABLE.reportTable TD, TABLE.reportTABLE TH {
	border: 1px inset #cccccc;
	vertical-align: top;
}
TABLE.reportTable {
    border: 1px solid #a9a9a9;
	border-collapse: collapse;
	width:100%;
	font-size:80%;
	padding-left:1em;
}
TABLE.reportTable TH {
  background: #e8e8f0;
}

TABLE.reportTable TD.error {
  background: #ffcccc;
  font-weight: bold;
}

TABLE.reportTable TR.even {
  background: #eee;  
}

IMG.latency {
  border:1px solid #a9a9a9
}
</xsl:variable>
</xsl:stylesheet>
