#!/bin/sh
echo "Important: Before installing the fix pack, make sure that the IBM Data Studio Administration Console is stopped. Do you want to install Fix Pack 1 for Data Studio Administration Console Version 1.2? (Y/N)"
read a
if [ "$a" = "Y" ] || [ "$a" = "y" ];then 
     VersionFile="version.txt"
     TEMP_DIR="$(pwd)"
     echo "Enter the home directory of DSAC. To stop this operation,press ^C:"
     read DSAC_HOME
     #echo $DSAC_HOME
     while [[ ! -d "$DSAC_HOME" ]] || [[ ! -d "$DSAC_HOME/apps" ]];do
          echo "The directory that you specified does not exist or is not the DSAC home directory. Enter the home directory of DSAC again. To stop the operation,press ^C:"
          read DSAC_HOME
     done 
     export JAVA_HOME=${DSAC_HOME}/jre/jre
     echo "Installing...it might take a few minutes."
     "$DSAC_HOME/bin/ant/bin/ant" -buildfile applypatch.xml -DDSAC_HOME="$DSAC_HOME" -DPRO_DIR=IBM_DSAC1.2.0_fixpack_1 install -verbose
     if [ "$?" = "0" ] ; then
       echo "Installation completed successfully."
     else
       echo "Installation failed."
     fi
else
     echo "Ended by user"
fi